local enemy = require "Enemy"

function love.load()

  math.randomseed(os.time())
  
  love.window.setFullscreen(true)
  sw,sh = love.window.getMode()

  enemies = {}

  timer = {
    sec = 0,
    min = 0,

    count = function(dt)
      timer.sec = timer.sec + dt

      if math.floor(timer.sec) >= 60 then
        timer.min = timer.min + 1
        timer.sec = 0
        for i = 1, 30 do
          table.insert(enemies, i, enemy())
        end
      end
    end,

    display = function()
      if timer.sec >= 10 and timer.min >= 10 then
        love.graphics.print(timer.min..":"..math.floor(timer.sec), sw/2, 0)
      elseif timer.sec >= 10 and timer.min < 10 then
        love.graphics.print("0"..timer.min..":"..math.floor(timer.sec), sw/2, 0)
      elseif timer.sec < 10 and timer.min >= 10 then
        love.graphics.print(timer.min..":".."0"..math.floor(timer.sec), sw/2, 0)
      elseif timer.sec < 10 and timer.min < 10 then
        love.graphics.print("0"..timer.min..":".."0"..math.floor(timer.sec), sw/2, 0)
      end
    end
      
  }

  tower = {
    size = 50,
    x = sw/2,
    y = sh/2,
    health = 100,

    draw = function(self)
      love.graphics.setColor(0,1,0)
      love.graphics.circle("fill", self.x, self.y, self.size)
      love.graphics.setColor(0,0,0)
      love.graphics.circle("line", self.x, self.y, self.size)
      love.graphics.setColor(1,1,1)
    end
  }
  
  for i = 1, 30 do
    table.insert(enemies, i, enemy())
  end

end

function love.update(dt)

  timer.count(dt)

  for i = #enemies, 1, -1 do
    enemies[i]:move(tower.x, tower.y)

    if math.sqrt((tower.x - (enemies[i].x + enemies[i].size))^2 + (tower.y - (enemies[i].y + enemies[i].size))^2) <= tower.size or math.sqrt((tower.x - enemies[i].x)^2 + (tower.y - enemies[i].y)^2) <= tower.size then
      tower.health = tower.health - 1
      table.remove(enemies, i)
    end
  end

end

function love.draw()

  love.graphics.rectangle("fill", 0, 0, sw, sh)

  love.graphics.setColor(0,0,0)
  love.graphics.print(tower.health, 0, 0)
  timer.display()
  love.graphics.setColor(1,1,1)
  
  tower:draw()

  for i = 1, #enemies do
    enemies[i]:draw()
  end
  
end